/* Generated by GOB (v1.0.10)   (do not edit directly) */

#include <gtk/gtk.h>

#ifndef __GO_CLIENT_H__
#define __GO_CLIENT_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#define __TYPEDEF_GO_CLIENT__
typedef struct _GoClient GoClient;

#include <go-data.h>

typedef  void (*GoClientPlayerFunc) (GoClient *c, GoPlayer *p,
				     int i, int n, gpointer client_data);
typedef  void (*GoClientGameFunc) (GoClient *c, GoGame *g,
				   int i, int n, gpointer client_data);

typedef  void (*go_cb) (GtkObject *obj, void *client_data);

typedef int (*GoComparePlayersFunc) (const GoPlayer *a, const GoPlayer *b, 
				     void *client_data);


/*
 * Type checking and casting macros
 */
#define GO_TYPE_CLIENT	(go_client_get_type())
#define GO_CLIENT(obj)	GTK_CHECK_CAST((obj), go_client_get_type(), GoClient)
#define GO_CLIENT_CONST(obj)	GTK_CHECK_CAST((obj), go_client_get_type(), GoClient const)
#define GO_CLIENT_CLASS(klass)	GTK_CHECK_CLASS_CAST((klass), go_client_get_type(), GoClientClass)
#define GO_IS_CLIENT(obj)	GTK_CHECK_TYPE((obj), go_client_get_type ())

#ifdef GTK_CHECK_GET_CLASS
#define GO_CLIENT_GET_CLASS(obj)	GTK_CHECK_GET_CLASS((obj), go_client_get_type(), GoClientClass)
#else /* !GTK_CHECK_GET_CLASS */
#define GO_CLIENT_GET_CLASS(obj)	((GoClientClass *)GTK_OBJECT(obj)->klass)
#endif /* GTK_CHECK_GET_CLASS */

/*
 * Main object structure
 */
#ifndef __TYPEDEF_GO_CLIENT__
#define __TYPEDEF_GO_CLIENT__
typedef struct _GoClient GoClient;
#endif
struct _GoClient {
	GtkObject __parent__;
	/*< public >*/
	GoData * data;
	/*< private >*/
	GPtrArray * players; /* protected */
	GPtrArray * games; /* protected */
	GoComparePlayersFunc compare_players_fn; /* protected */
	void * compare_players_data; /* protected */
};

/*
 * Class definition
 */
typedef struct _GoClientClass GoClientClass;
struct _GoClientClass {
	GtkObjectClass __parent__;
	void (* register_player) (GoClient * self, GoPlayer * player);
	void (* unregister_player) (GoClient * self, GoPlayer * player);
	void (* register_game) (GoClient * self, GoGame * game);
	void (* unregister_game) (GoClient * self, GoGame * game);
	void (* print_player) (GoClient * self, GoPlayer * player, int i, int n);
	void (* print_game) (GoClient * self, GoGame * game, int i, int n);
	void (* select_game) (GoClient * self, GoGame * g, int i);
};


/*
 * Public methods
 */
GtkType	go_client_get_type	(void) G_GNUC_CONST;
void 	go_client_register_player	(GoClient * self,
					GoPlayer * player);
void 	go_client_unregister_player	(GoClient * self,
					GoPlayer * player);
int 	go_client_player_count	(GoClient * self);
GoPlayer * 	go_client_player	(GoClient * self,
					int i);
void 	go_client_foreach_player	(GoClient * self,
					GoClientPlayerFunc f,
					void * data);
void 	go_client_sort_players	(GoClient * self,
					GoComparePlayersFunc compare_players_fn,
					gpointer client_data);
void 	go_client_register_game	(GoClient * self,
					GoGame * game);
void 	go_client_unregister_game	(GoClient * self,
					GoGame * game);
int 	go_client_game_count	(GoClient * self);
GoGame * 	go_client_game	(GoClient * self,
					int i);
void 	go_client_foreach_game	(GoClient * self,
					GoClientGameFunc f,
					void * data);
void 	go_client_redisplay	(GoClient * self,
					gboolean games,
					gboolean players);
void 	go_client_make_game_visible	(GoClient * self,
					GoGame * g);
void 	go_client_print_player	(GoClient * self,
					GoPlayer * player,
					int i,
					int n);
void 	go_client_print_game	(GoClient * self,
					GoGame * game,
					int i,
					int n);
void 	go_client_select_game	(GoClient * self,
					GoGame * g,
					int i);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
