/* Generated by GOB (v1.0.10)   (do not edit directly) */

#include <gtk/gtk.h>

#ifndef __GO_DATA_H__
#define __GO_DATA_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#define __TYPEDEF_GO_DATA__
typedef struct _GoData GoData;

#include <go-player.h>
#include <go-game.h>
#include <go-client.h>


/*
 * Type checking and casting macros
 */
#define GO_TYPE_DATA	(go_data_get_type())
#define GO_DATA(obj)	GTK_CHECK_CAST((obj), go_data_get_type(), GoData)
#define GO_DATA_CONST(obj)	GTK_CHECK_CAST((obj), go_data_get_type(), GoData const)
#define GO_DATA_CLASS(klass)	GTK_CHECK_CLASS_CAST((klass), go_data_get_type(), GoDataClass)
#define GO_IS_DATA(obj)	GTK_CHECK_TYPE((obj), go_data_get_type ())

#ifdef GTK_CHECK_GET_CLASS
#define GO_DATA_GET_CLASS(obj)	GTK_CHECK_GET_CLASS((obj), go_data_get_type(), GoDataClass)
#else /* !GTK_CHECK_GET_CLASS */
#define GO_DATA_GET_CLASS(obj)	((GoDataClass *)GTK_OBJECT(obj)->klass)
#endif /* GTK_CHECK_GET_CLASS */

/*
 * Main object structure
 */
#ifndef __TYPEDEF_GO_DATA__
#define __TYPEDEF_GO_DATA__
typedef struct _GoData GoData;
#endif
struct _GoData {
	GtkObject __parent__;
	/*< private >*/
	GSList * clients; /* protected */
	GSList * players; /* protected */
	GSList * games; /* protected */
	GList * tokens; /* protected */
	GtkObject * components; /* protected */
	gint frozen; /* protected */
	gboolean players_changed; /* protected */
	gboolean games_changed; /* protected */
	GoGame * game_selected; /* protected */
};

/*
 * Class definition
 */
typedef struct _GoDataClass GoDataClass;
struct _GoDataClass {
	GtkObjectClass __parent__;
	/*signal*/void (* changed) (GoData * self);
};


/*
 * Public methods
 */
GtkType	go_data_get_type	(void) G_GNUC_CONST;
GtkObject * 	go_data_new	(void);
void 	go_data_clear	(GoData * self);
gboolean 	go_data_load	(GoData * self,
					const gchar * filename);
gboolean 	go_data_save	(GoData * self,
					const gchar * filename);
void 	go_data_notify_players_changed	(GoData * self);
void 	go_data_notify_games_changed	(GoData * self);
void 	go_data_add_client	(GoData * self,
					GoClient * client);
void 	go_data_remove_client	(GoData * self,
					GoClient * client);
void 	go_data_add_player	(GoData * self,
					GoPlayer * player);
void 	go_data_remove_player	(GoData * self,
					GoPlayer * player);
void 	go_data_player_lock	(GoData * self,
					GoPlayer * p);
void 	go_data_player_unlock	(GoData * self,
					GoPlayer * p);
int 	go_data_player_count	(GoData * self);
GList * 	go_data_player_tokens	(GoData * self);
GoPlayer * 	go_data_find_token	(GoData * self,
					const char * token);
int 	go_data_player_game_count	(GoData * self,
					GoPlayer * player);
int 	go_data_player_win_count	(GoData * self,
					GoPlayer * player);
int 	go_data_player_game_index	(GoData * self,
					GoPlayer * player,
					GoGame * game);
int 	go_data_player_component	(GoData * self,
					const GoPlayer * player);
gboolean 	go_data_players_equiv	(GoData * self,
					const GoPlayer * a,
					const GoPlayer * b);
void 	go_data_add_game	(GoData * self,
					GoGame * game);
void 	go_data_remove_game	(GoData * self,
					GoGame * game);
void 	go_data_game_lock	(GoData * self,
					GoGame * g);
void 	go_data_game_unlock	(GoData * self,
					GoGame * g);
int 	go_data_game_count	(GoData * self);

/*
 * Signal connection wrapper macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define GO_DATA_SIGNAL_CHANGED(func)	"changed",GTK_SIGNAL_FUNC(({void (* ___changed) (GoData * self, gpointer data ) = func; ___changed; }))
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define GO_DATA_SIGNAL_CHANGED(func)	"changed",GTK_SIGNAL_FUNC(func)
#endif /* __GNUC__ && !__STRICT_ANSI__ */


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
