/* Generated by GOB (v1.0.10) on Sat Sep  1 19:43:01 2001
   (do not edit directly) */

/* End world hunger, donate to the World Food Programme, http://www.wfp.org */

#define GOB_VERSION_MAJOR 1
#define GOB_VERSION_MINOR 0
#define GOB_VERSION_PATCHLEVEL 10

#include "go-game.h"


#line 26 "go-game.gob"

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>

#include "go.h"


static time_t
str_to_time (const char *str)
{
  if (str) {
    struct tm  broken_time;
    broken_time.tm_sec = 0;
    broken_time.tm_min = 0;
    broken_time.tm_hour = 0;
    sscanf (str, "%d.%d.%d",
	    &broken_time.tm_mday, &broken_time.tm_mon, &broken_time.tm_year);
    broken_time.tm_mon -= 1;
    broken_time.tm_year -= 1900;
    broken_time.tm_isdst = -1;

    return  mktime (&broken_time);
  } else {
    return  0;
  }
}

static char *
time_to_str (time_t t)
{
  struct tm *broken_time;

  broken_time = localtime (&t);
  if (t == 0 || broken_time == NULL)  return NULL;
  return  g_strdup_printf ("%d.%d.%d",
			   broken_time->tm_mday,
			   broken_time->tm_mon + 1,
			   broken_time->tm_year + 1900);
}

GoBoardSize
str_to_board (const char *str)
{
  GoBoardSize  res;
  
  if (! str || strcmp (str, "19") == 0) {
    res = b19;
  } else if (strcmp (str, "13") == 0) {
    res = b13;
  } else if (strcmp (str, "9") == 0) {
    res = b9;
  } else {
    g_assert_not_reached ();
    res = -1;
  }
  return  res;
}

/**
 * board_to_str:
 * @board: a board size
 *
 * Convert @board to a human-understandable textual representation.
 *
 * Returns: the board size as a string.
 */
const char *
board_to_str (GoBoardSize board)
{
  const char *str;

  switch (board) {
  case b19:
    str = "19";
    break;
  case b13:
    str = "13";
    break;
  case b9:
    str = "9";
    break;
  default:
    g_assert_not_reached ();
    str = NULL;
  }
  return  str;
}

GoGameResult
str_to_result (const char *str)
{
  GoGameResult  res;

  if (! str)  return -1;
  
  if (strcmp (str, "black") == 0) {
    res = res_BLACK;
  } else if (strcmp (str, "white") == 0) {
    res = res_WHITE;
  } else if (strcmp (str, "jigo") == 0) {
    res = res_JIGO;
  } else {
    g_assert_not_reached ();
    res = -1;
  }
  return  res;
}

/**
 * result_to_str:
 * @res: a game result
 *
 * Convert @res to human understandable textual representation.
 *
 * Returns: the result as a string.
 */
const char *
result_to_str (GoGameResult res)
{
  const char *str;

  switch (res) {
  case res_BLACK:
    str = "black";
    break;
  case res_WHITE:
    str = "white";
    break;
  case res_JIGO:
    str = "jigo";
    break;
  default:
    g_assert_not_reached ();
    str = NULL;
  }
  return  str;
}

#line 156 "go-game.c"
/* self casting macros */
#define SELF(x) GO_GAME(x)
#define SELF_CONST(x) GO_GAME_CONST(x)
#define IS_SELF(x) GO_IS_GAME(x)
#define TYPE_SELF GO_TYPE_GAME
#define SELF_CLASS(x) GO_GAME_CLASS(x)

#define SELF_GET_CLASS(x) GO_GAME_GET_CLASS(x)

/* self typedefs */
typedef GoGame Self;
typedef GoGameClass SelfClass;

/* GTK_CLASS_TYPE for 1.2<->1.3/2.0 GTK+ compatibility */
#ifndef GTK_CLASS_TYPE
#define GTK_CLASS_TYPE(x) (GTK_OBJECT_CLASS(x)->type)
#endif /* GTK_CLASS_TYPE */

/* here are local prototypes */
static void ___object_set_arg (GtkObject *object, GtkArg *arg, guint arg_id);
static void ___object_get_arg (GtkObject *object, GtkArg *arg, guint arg_id);
static void go_game_init (GoGame * o) G_GNUC_UNUSED;
static void go_game_class_init (GoGameClass * c) G_GNUC_UNUSED;
static void ___1_go_game_destroy (GtkObject * obj) G_GNUC_UNUSED;
static void ___real_go_game_write (GoGame * self, xmlNodePtr node);

enum {
	ARG_0,
	ARG_BLACK,
	ARG_WHITE,
	ARG_BOARD,
	ARG_HANDICAP,
	ARG_KOMI
};

/* pointer to the class of our parent */
static GtkObjectClass *parent_class = NULL;

GtkType
go_game_get_type (void)
{
	static GtkType type = 0;

	if (type == 0) {
		static const GtkTypeInfo info = {
			"GoGame",
			sizeof (GoGame),
			sizeof (GoGameClass),
			(GtkClassInitFunc) go_game_class_init,
			(GtkObjectInitFunc) go_game_init,
			/* reserved_1 */ NULL,
			/* reserved_2 */ NULL,
			(GtkClassInitFunc) NULL
		};

		type = gtk_type_unique (gtk_object_get_type(), &info);
	}

	return type;
}

/* Short form macros */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define new(args...) go_game_new(args)
#define new_fake(args...) go_game_new_fake(args)
#define write(args...) go_game_write(args)
#define read(args...) go_game_read(args)
#endif /* __GNUC__ && !__STRICT_ANSI__ */

/* Short form pointers */
static GtkObject * (* const new) (GoData * data, time_t date, const char * black, const char * white, GoBoardSize board, int handicap, double komi, GoGameResult res) = go_game_new;
static GtkObject * (* const new_fake) (GoData * data) = go_game_new_fake;
static void (* const write) (GoGame * self, xmlNodePtr node) = go_game_write;
static GtkObject * (* const read) (GoData * data, xmlNodePtr node) = go_game_read;

/* a macro for creating a new object of our type */
#define GET_NEW ((GoGame *)gtk_type_new(go_game_get_type()))

static void 
go_game_init (GoGame * o)
{
#define __GOB_FUNCTION__ "Go:Game::init"
#line 26 "go-game.gob"
	o->data = NULL;
#line 241 "go-game.c"
#line 26 "go-game.gob"
	o->date = 0;
#line 244 "go-game.c"
#line 198 "go-game.gob"
	o->locked = FALSE;
#line 247 "go-game.c"
#line 198 "go-game.gob"
	o->fake = FALSE;
#line 250 "go-game.c"
#line 198 "go-game.gob"
	o->probability = -1;
#line 253 "go-game.c"
#line 198 "go-game.gob"
	o->black_game_index = -1;
#line 256 "go-game.c"
#line 198 "go-game.gob"
	o->white_game_index = -1;
#line 259 "go-game.c"
	return;
	o = NULL;
}
#undef __GOB_FUNCTION__
static void 
go_game_class_init (GoGameClass * c)
{
#define __GOB_FUNCTION__ "Go:Game::class_init"
	GtkObjectClass *gtk_object_class = (GtkObjectClass*) c;
#ifdef G_OBJECT_CLASS
	GObjectClass *g_object_class = (GObjectClass*) c;
#endif /* G_OBJECT_CLASS */

	parent_class = gtk_type_class (gtk_object_get_type ());

#line 215 "go-game.gob"
	gtk_object_class->destroy = ___1_go_game_destroy;
#line 286 "go-game.gob"
	c->write = ___real_go_game_write;
#line 279 "go-game.c"

	gtk_object_add_arg_type("GoGame::black",
		GTK_TYPE_POINTER,
		GTK_ARG_READWRITE,
		ARG_BLACK);
	gtk_object_add_arg_type("GoGame::white",
		GTK_TYPE_POINTER,
		GTK_ARG_READWRITE,
		ARG_WHITE);
	gtk_object_add_arg_type("GoGame::board",
		GTK_TYPE_POINTER,
		GTK_ARG_READWRITE,
		ARG_BOARD);
	gtk_object_add_arg_type("GoGame::handicap",
		GTK_TYPE_INT,
		GTK_ARG_READWRITE,
		ARG_HANDICAP);
	gtk_object_add_arg_type("GoGame::komi",
		GTK_TYPE_DOUBLE,
		GTK_ARG_READWRITE,
		ARG_KOMI);

	gtk_object_class->get_arg = ___object_get_arg;
	gtk_object_class->set_arg = ___object_set_arg;
	return;
	c = NULL;
	gtk_object_class = NULL;
#ifdef G_OBJECT_CLASS
	g_object_class = NULL;
#endif /* G_OBJECT_CLASS */
}
#undef __GOB_FUNCTION__

static void
___object_set_arg (GtkObject *object,
	GtkArg *arg,
	guint arg_id)
#define __GOB_FUNCTION__ "Go:Game::set_arg"
{
	GoGame *self;

	self = GO_GAME (object);

	switch (arg_id) {
	case ARG_BLACK:
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define ARG ({char *  foo = GTK_VALUE_POINTER(*arg); foo; })
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define ARG ((char * )GTK_VALUE_POINTER(*arg))
#endif /* __GNUC__ && !__STRICT_ANSI__ */

		{
#line 175 "go-game.gob"
 self->black = go_data_find_token (self->data, ARG); 
#line 334 "go-game.c"
		}
		break;
#undef ARG
	case ARG_WHITE:
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define ARG ({char *  foo = GTK_VALUE_POINTER(*arg); foo; })
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define ARG ((char * )GTK_VALUE_POINTER(*arg))
#endif /* __GNUC__ && !__STRICT_ANSI__ */

		{
#line 180 "go-game.gob"
 self->white = go_data_find_token (self->data, ARG); 
#line 348 "go-game.c"
		}
		break;
#undef ARG
	case ARG_BOARD:
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define ARG ({char *  foo = GTK_VALUE_POINTER(*arg); foo; })
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define ARG ((char * )GTK_VALUE_POINTER(*arg))
#endif /* __GNUC__ && !__STRICT_ANSI__ */

		{
#line 185 "go-game.gob"
 self->board = str_to_board (ARG); 
#line 362 "go-game.c"
		}
		break;
#undef ARG
	case ARG_HANDICAP:
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define ARG ({int  foo = GTK_VALUE_INT(*arg); foo; })
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define ARG ((int )GTK_VALUE_INT(*arg))
#endif /* __GNUC__ && !__STRICT_ANSI__ */

		{
#line 189 "go-game.gob"
self->handicap = ARG;
#line 376 "go-game.c"
		}
		break;
#undef ARG
	case ARG_KOMI:
#define ARG (GTK_VALUE_DOUBLE(*arg))
		{
#line 194 "go-game.gob"

      self->komi = (int)(ARG+10000)-10000;
      self->with_jigo = (ARG == self->komi);
    
#line 388 "go-game.c"
		}
		break;
#undef ARG
	default:
		break;
	}
	return;
	self = NULL;
	arg = NULL;
}
#undef __GOB_FUNCTION__

static void
___object_get_arg (GtkObject *object,
	GtkArg *arg,
	guint arg_id)
#define __GOB_FUNCTION__ "Go:Game::get_arg"
{
	GoGame *self;

	self = GO_GAME (object);

	switch (arg_id) {
	case ARG_BLACK:
#define ARG (GTK_VALUE_POINTER(*arg))
		{
#line 176 "go-game.gob"
 ARG = g_strdup (self->black->token); 
#line 417 "go-game.c"
		}
		break;
#undef ARG
	case ARG_WHITE:
#define ARG (GTK_VALUE_POINTER(*arg))
		{
#line 181 "go-game.gob"
 ARG = g_strdup (self->white->token); 
#line 426 "go-game.c"
		}
		break;
#undef ARG
	case ARG_BOARD:
#define ARG (GTK_VALUE_POINTER(*arg))
		{
#line 186 "go-game.gob"
 ARG = g_strdup (board_to_str(self->board)); 
#line 435 "go-game.c"
		}
		break;
#undef ARG
	case ARG_HANDICAP:
#define ARG (GTK_VALUE_INT(*arg))
		{
#line 189 "go-game.gob"
ARG = self->handicap;
#line 444 "go-game.c"
		}
		break;
#undef ARG
	case ARG_KOMI:
#define ARG (GTK_VALUE_DOUBLE(*arg))
		{
#line 198 "go-game.gob"

      if (self->with_jigo) {
        ARG = self->komi;
      } else {
	ARG = self->komi + 0.5;
      }
    
#line 459 "go-game.c"
		}
		break;
#undef ARG
	default:
		break;
	}
	return;
	self = NULL;
	arg = NULL;
}
#undef __GOB_FUNCTION__



#line 215 "go-game.gob"
static void 
___1_go_game_destroy (GtkObject * obj)
#line 477 "go-game.c"
#define PARENT_HANDLER(___obj) \
	{ if(GTK_OBJECT_CLASS(parent_class)->destroy) \
		(* GTK_OBJECT_CLASS(parent_class)->destroy)(___obj); }
{
#define __GOB_FUNCTION__ "Go:Game::destroy"
{
#line 217 "go-game.gob"
	
    GoGame *self = GO_GAME (obj);
    if (self->data)  go_data_remove_game (self->data, self);

    PARENT_HANDLER (obj);
  }}
#line 491 "go-game.c"
#undef __GOB_FUNCTION__
#undef PARENT_HANDLER

/**
 * go_game_new:
 * @data: a #GoData object
 * @date: the date of the game in the form %dd.mm.yyyy
 * @black: the black player's token
 * @white: the white player's token
 * @board: the board size
 * @handicap: the number of handicap stones (in favour of black)
 * @komi: the amount of komi (in favour of white)
 * @res: the game's outcome
 *
 * Allocate a new #GoGame object, fill it with values, and
 * connect it to @data.
 *
 * Returns: a newly allocated #GoGame object.
 **/
#line 240 "go-game.gob"
GtkObject * 
go_game_new (GoData * data, time_t date, const char * black, const char * white, GoBoardSize board, int handicap, double komi, GoGameResult res)
#line 514 "go-game.c"
{
#define __GOB_FUNCTION__ "Go:Game::new"
#line 240 "go-game.gob"
	g_return_val_if_fail (black != NULL, (GtkObject * )0);
#line 240 "go-game.gob"
	g_return_val_if_fail (white != NULL, (GtkObject * )0);
#line 521 "go-game.c"
{
#line 244 "go-game.gob"
	
    GoGame *g = GET_NEW;

    g->black = go_data_find_token (data, black);
    g->white = go_data_find_token (data, white);
    g->date = date;
    g->board = board;
    gtk_object_set (GTK_OBJECT (g),
		    GO_GAME_ARG_HANDICAP (handicap),
		    GO_GAME_ARG_KOMI (komi),
		    NULL);
    g->res = res;
    go_data_add_game (data, g);
    return  GTK_OBJECT (g);
  }}
#line 539 "go-game.c"
#undef __GOB_FUNCTION__

/**
 * go_game_new_fake:
 * @data: a #GoData object
 *
 * Allocate a new fake #GoGame object and connect it to @data.  This
 * object may be used for internal purposes and does not correspond
 * to a real game.  The data must be filled in manually.
 *
 * Returns: a newly allocated #GoGame object.
 **/
#line 270 "go-game.gob"
GtkObject * 
go_game_new_fake (GoData * data)
#line 555 "go-game.c"
{
#define __GOB_FUNCTION__ "Go:Game::new_fake"
{
#line 271 "go-game.gob"
	
    GoGame *g = GET_NEW;

    g->fake = TRUE;
    go_data_add_game (data, g);
    return  GTK_OBJECT (g);
  }}
#line 567 "go-game.c"
#undef __GOB_FUNCTION__

/**
 * go_game_write:
 * @self: a #GoGame object
 * @node: a XML element of type "game"
 *
 * Dump all game data into @node.
 **/
#line 286 "go-game.gob"
void 
go_game_write (GoGame * self, xmlNodePtr node)
#line 580 "go-game.c"
{
	GoGameClass *klass;
#line 286 "go-game.gob"
	g_return_if_fail (self != NULL);
#line 286 "go-game.gob"
	g_return_if_fail (GO_IS_GAME (self));
#line 587 "go-game.c"
	klass = GO_GAME_GET_CLASS(self);

	if(klass->write)
		(*klass->write)(self,node);
}
#line 286 "go-game.gob"
static void 
___real_go_game_write (GoGame * self, xmlNodePtr node)
#line 596 "go-game.c"
{
#define __GOB_FUNCTION__ "Go:Game::write"
{
#line 288 "go-game.gob"
	
    char *date_str, *black_str, *white_str, *board_str;

    gtk_object_get (GTK_OBJECT (self),
		    GO_GAME_GET_ARG_BLACK (&black_str),
		    GO_GAME_GET_ARG_WHITE (&white_str),
		    GO_GAME_GET_ARG_BOARD (&board_str),
		    NULL);

    date_str = time_to_str (self->date);
    if (date_str) {
      xmlSetProp (node, "date", date_str);
      g_free (date_str);
    }
    xmlSetProp (node, "black", black_str);
    g_free (black_str);
    xmlSetProp (node, "white", white_str);
    g_free (white_str);
    xmlSetProp (node, "board", board_str);
    g_free (board_str);
    if (self->handicap) {
      char  buffer [32];
      g_snprintf (buffer, 32, "%d", self->handicap);
      xmlSetProp (node, "handicap", buffer);
    }
    if (self->komi || ! self->with_jigo) {
      char  buffer [32];
      if (self->with_jigo) {
	g_snprintf (buffer, 32, "%d", self->komi);
      } else {
	g_snprintf (buffer, 32, "%.1f", self->komi+0.5);
      }
      xmlSetProp (node, "komi", buffer);
    }
    xmlSetProp (node, "res", result_to_str (self->res));
  }}
#line 637 "go-game.c"
#undef __GOB_FUNCTION__

/**
 * go_game_read:
 * @data: a #GoData object
 * @node: a XML element of type "game"
 *
 * This is a constructor for #GoGame objects,
 * which reads all data from a XML tree.
 *
 * Returns: a newly allocated #GoGame object.
 **/
#line 335 "go-game.gob"
GtkObject * 
go_game_read (GoData * data, xmlNodePtr node)
#line 653 "go-game.c"
{
#define __GOB_FUNCTION__ "Go:Game::read"
#line 335 "go-game.gob"
	g_return_val_if_fail (data != NULL, (GtkObject * )0);
#line 335 "go-game.gob"
	g_return_val_if_fail (GO_IS_DATA (data), (GtkObject * )0);
#line 660 "go-game.c"
{
#line 336 "go-game.gob"
	
    time_t  date;
    char *black, *white, *board, *handicap_str, *komi_str, *result;
    int  handicap;
    double  komi;

    date = str_to_time (xmlGetProp (node, "date"));
    black = xmlGetProp (node, "black");
    white = xmlGetProp (node, "white");
    board = xmlGetProp (node, "board");
    handicap_str = xmlGetProp (node, "handicap");
    handicap = str_to_int (handicap_str, 0);
    komi_str = xmlGetProp (node, "komi");
    komi = str_to_double (komi_str, 0);
    result = xmlGetProp (node, "res");
    return  go_game_new (data, date, black, white, 
			 str_to_board (board), handicap, komi,
			 str_to_result (result));
  }}
#line 682 "go-game.c"
#undef __GOB_FUNCTION__


#if (!defined __GNUC__) || (defined __GNUC__ && defined __STRICT_ANSI__)
/*REALLY BAD HACK
  This is to avoid unused warnings if you don't call
  some method.  I need to find a better way to do
  this, not needed in GCC since we use some gcc
  extentions to make saner, faster code */
static void
___go_game_really_bad_hack_to_avoid_warnings(void)
{
	((void (*)(void))new)();
	((void (*)(void))new_fake)();
	((void (*)(void))write)();
	((void (*)(void))read)();
	___go_game_really_bad_hack_to_avoid_warnings();
}
#endif /* !__GNUC__ || (__GNUC__ && __STRICT_ANSI__) */

