/* Generated by GOB (v1.0.10)   (do not edit directly) */

#include <gtk/gtk.h>

#ifndef __GO_GAME_H__
#define __GO_GAME_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#include <time.h>
#include <gnome-xml/tree.h>

#define __TYPEDEF_GO_GAME__
typedef struct _GoGame GoGame;

#include "go-data.h"
#include "go-player.h"

typedef enum { b19=19, b13=13, b9=9 } GoBoardSize;
extern  const char *board_to_str (GoBoardSize board);
extern  GoBoardSize  str_to_board (const char *str);

typedef enum { res_BLACK, res_WHITE, res_JIGO } GoGameResult;
extern  const char *result_to_str (GoGameResult res);
extern  GoGameResult  str_to_result (const char *str);


/*
 * Type checking and casting macros
 */
#define GO_TYPE_GAME	(go_game_get_type())
#define GO_GAME(obj)	GTK_CHECK_CAST((obj), go_game_get_type(), GoGame)
#define GO_GAME_CONST(obj)	GTK_CHECK_CAST((obj), go_game_get_type(), GoGame const)
#define GO_GAME_CLASS(klass)	GTK_CHECK_CLASS_CAST((klass), go_game_get_type(), GoGameClass)
#define GO_IS_GAME(obj)	GTK_CHECK_TYPE((obj), go_game_get_type ())

#ifdef GTK_CHECK_GET_CLASS
#define GO_GAME_GET_CLASS(obj)	GTK_CHECK_GET_CLASS((obj), go_game_get_type(), GoGameClass)
#else /* !GTK_CHECK_GET_CLASS */
#define GO_GAME_GET_CLASS(obj)	((GoGameClass *)GTK_OBJECT(obj)->klass)
#endif /* GTK_CHECK_GET_CLASS */

/*
 * Main object structure
 */
#ifndef __TYPEDEF_GO_GAME__
#define __TYPEDEF_GO_GAME__
typedef struct _GoGame GoGame;
#endif
struct _GoGame {
	GtkObject __parent__;
	/*< public >*/
	GoPlayer * black;
	GoPlayer * white;
	GoGameResult res;
	double probability;
	/*< private >*/
	GoData * data; /* protected */
	time_t date; /* protected */
	GoBoardSize board; /* protected */
	int handicap; /* protected */
	int komi; /* protected */
	gboolean with_jigo; /* protected */
	gboolean locked; /* protected */
	gboolean fake; /* protected */
	int black_game_index; /* protected */
	int white_game_index; /* protected */
};

/*
 * Class definition
 */
typedef struct _GoGameClass GoGameClass;
struct _GoGameClass {
	GtkObjectClass __parent__;
	void (* write) (GoGame * self, xmlNodePtr node);
};


/*
 * Public methods
 */
GtkType	go_game_get_type	(void) G_GNUC_CONST;
GtkObject * 	go_game_new	(GoData * data,
					time_t date,
					const char * black,
					const char * white,
					GoBoardSize board,
					int handicap,
					double komi,
					GoGameResult res);
GtkObject * 	go_game_new_fake	(GoData * data);
void 	go_game_write	(GoGame * self,
					xmlNodePtr node);
GtkObject * 	go_game_read	(GoData * data,
					xmlNodePtr node);

/*
 * Argument wrapping macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define GO_GAME_ARG_BLACK(arg)    	"black",({char * z = (arg); z;})
#define GO_GAME_GET_ARG_BLACK(arg)	"black",({char * *z = (arg); z;})
#define GO_GAME_ARG_WHITE(arg)    	"white",({char * z = (arg); z;})
#define GO_GAME_GET_ARG_WHITE(arg)	"white",({char * *z = (arg); z;})
#define GO_GAME_ARG_BOARD(arg)    	"board",({char * z = (arg); z;})
#define GO_GAME_GET_ARG_BOARD(arg)	"board",({char * *z = (arg); z;})
#define GO_GAME_ARG_HANDICAP(arg)    	"handicap",({int z = (arg); z;})
#define GO_GAME_GET_ARG_HANDICAP(arg)	"handicap",({int *z = (arg); z;})
#define GO_GAME_ARG_KOMI(arg)    	"komi",({gdouble z = (arg); z;})
#define GO_GAME_GET_ARG_KOMI(arg)	"komi",({gdouble *z = (arg); z;})
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define GO_GAME_ARG_BLACK(arg)    	"black",(char * )(arg)
#define GO_GAME_GET_ARG_BLACK(arg)	"black",(char * *)(arg)
#define GO_GAME_ARG_WHITE(arg)    	"white",(char * )(arg)
#define GO_GAME_GET_ARG_WHITE(arg)	"white",(char * *)(arg)
#define GO_GAME_ARG_BOARD(arg)    	"board",(char * )(arg)
#define GO_GAME_GET_ARG_BOARD(arg)	"board",(char * *)(arg)
#define GO_GAME_ARG_HANDICAP(arg)    	"handicap",(int )(arg)
#define GO_GAME_GET_ARG_HANDICAP(arg)	"handicap",(int *)(arg)
#define GO_GAME_ARG_KOMI(arg)    	"komi",(gdouble )(arg)
#define GO_GAME_GET_ARG_KOMI(arg)	"komi",(gdouble *)(arg)
#endif /* __GNUC__ && !__STRICT_ANSI__ */


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
