/* Generated by GOB (v1.0.10) on Sat Sep  1 19:43:01 2001
   (do not edit directly) */

/* End world hunger, donate to the World Food Programme, http://www.wfp.org */

#define GOB_VERSION_MAJOR 1
#define GOB_VERSION_MINOR 0
#define GOB_VERSION_PATCHLEVEL 10

#include <string.h> /* memset() */

#include "go-player.h"


#line 18 "go-player.gob"

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>

#include "go.h"


/**
 * rank_to_strength:
 * @rank: a player's rank
 * @strength_ptr: a pointer to the place where the strength value
 *   should be filled in.
 *
 * Convert a rank string of the form "3d" or "5k" into a numerical
 * strength value.  @rank must be an integer number x, followed
 * by either %d (for dan grades) or %k (for kyu grades).
 * The computed strength value is x-1 for "x dan" or -x for "x kyu".
 *
 * @rank may be %NULL or the empty string.  In this case
 * the strength value -100 (meaning "unknown strength") is returned.
 *
 * Returns: %TRUE if the conversion was succesful and %FALSE on error.
 */
gboolean
rank_to_strength (const char *rank, double *strength_ptr)
{
  int  res, val;
  char  c;

  if (! (rank && *rank)) {
    *strength_ptr = -100;
    return  TRUE;
  }
  res = sscanf (rank, "%d%c", &val, &c);
  if (! (res == 2 && (c == 'k' || c == 'd'))) {
    return  FALSE;
  }
  *strength_ptr = (c == 'k') ? -val : val-1;
  return  TRUE;
}

#line 61 "go-player.c"
/* self casting macros */
#define SELF(x) GO_PLAYER(x)
#define SELF_CONST(x) GO_PLAYER_CONST(x)
#define IS_SELF(x) GO_IS_PLAYER(x)
#define TYPE_SELF GO_TYPE_PLAYER
#define SELF_CLASS(x) GO_PLAYER_CLASS(x)

#define SELF_GET_CLASS(x) GO_PLAYER_GET_CLASS(x)

/* self typedefs */
typedef GoPlayer Self;
typedef GoPlayerClass SelfClass;

/* GTK_CLASS_TYPE for 1.2<->1.3/2.0 GTK+ compatibility */
#ifndef GTK_CLASS_TYPE
#define GTK_CLASS_TYPE(x) (GTK_OBJECT_CLASS(x)->type)
#endif /* GTK_CLASS_TYPE */

/* here are local prototypes */
static void ___object_set_arg (GtkObject *object, GtkArg *arg, guint arg_id);
static void ___object_get_arg (GtkObject *object, GtkArg *arg, guint arg_id);
static void go_player_init (GoPlayer * o) G_GNUC_UNUSED;
static void go_player_class_init (GoPlayerClass * c) G_GNUC_UNUSED;
static void ___real_go_player_write (GoPlayer * self, xmlNodePtr node);
static void ___2_go_player_destroy (GtkObject * obj) G_GNUC_UNUSED;

enum {
	ARG_0,
	ARG_NAME,
	ARG_TOKEN,
	ARG_RANK,
	ARG_STRENGTH
};

/* pointer to the class of our parent */
static GtkObjectClass *parent_class = NULL;

GtkType
go_player_get_type (void)
{
	static GtkType type = 0;

	if (type == 0) {
		static const GtkTypeInfo info = {
			"GoPlayer",
			sizeof (GoPlayer),
			sizeof (GoPlayerClass),
			(GtkClassInitFunc) go_player_class_init,
			(GtkObjectInitFunc) go_player_init,
			/* reserved_1 */ NULL,
			/* reserved_2 */ NULL,
			(GtkClassInitFunc) NULL
		};

		type = gtk_type_unique (gtk_object_get_type(), &info);
	}

	return type;
}

/* Short form macros */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define write(args...) go_player_write(args)
#define new(args...) go_player_new(args)
#define read(args...) go_player_read(args)
#endif /* __GNUC__ && !__STRICT_ANSI__ */

/* Short form pointers */
static void (* const write) (GoPlayer * self, xmlNodePtr node) = go_player_write;
static GtkObject * (* const new) (GoData * data, const char * name, const char * token, const char * rank, double strength) = go_player_new;
static GtkObject * (* const read) (GoData * data, xmlNodePtr node) = go_player_read;

/* a macro for creating a new object of our type */
#define GET_NEW ((GoPlayer *)gtk_type_new(go_player_get_type()))


static void
___destroy(GtkObject *obj_self)
{
#define __GOB_FUNCTION__ "Go:Player::destroy"
	GoPlayer *self = GO_PLAYER (obj_self);
#line 105 "go-player.gob"
	___2_go_player_destroy(obj_self);
#line 145 "go-player.c"
#line 67 "go-player.gob"
	if(self->name) { ((*(void (*)(void *))g_free)) (self->name); self->name = NULL; }
#line 148 "go-player.c"
#line 71 "go-player.gob"
	if(self->token) { ((*(void (*)(void *))g_free)) (self->token); self->token = NULL; }
#line 151 "go-player.c"
#line 75 "go-player.gob"
	if(self->rank) { ((*(void (*)(void *))g_free)) (self->rank); self->rank = NULL; }
#line 154 "go-player.c"
	return;
	self = NULL;
}
#undef __GOB_FUNCTION__

static void 
go_player_init (GoPlayer * o)
{
#define __GOB_FUNCTION__ "Go:Player::init"
#line 18 "go-player.gob"
	o->data = NULL;
#line 166 "go-player.c"
#line 18 "go-player.gob"
	o->locked = FALSE;
#line 169 "go-player.c"
	return;
	o = NULL;
}
#undef __GOB_FUNCTION__
static void 
go_player_class_init (GoPlayerClass * c)
{
#define __GOB_FUNCTION__ "Go:Player::class_init"
	GtkObjectClass *gtk_object_class = (GtkObjectClass*) c;
#ifdef G_OBJECT_CLASS
	GObjectClass *g_object_class = (GObjectClass*) c;
#endif /* G_OBJECT_CLASS */

	parent_class = gtk_type_class (gtk_object_get_type ());

#line 92 "go-player.gob"
	c->write = ___real_go_player_write;
#line 105 "go-player.gob"
	gtk_object_class->destroy = ___destroy;
#line 189 "go-player.c"

	gtk_object_add_arg_type("GoPlayer::name",
		GTK_TYPE_POINTER,
		GTK_ARG_READWRITE | GTK_ARG_CONSTRUCT,
		ARG_NAME);
	gtk_object_add_arg_type("GoPlayer::token",
		GTK_TYPE_POINTER,
		GTK_ARG_READWRITE | GTK_ARG_CONSTRUCT_ONLY,
		ARG_TOKEN);
	gtk_object_add_arg_type("GoPlayer::rank",
		GTK_TYPE_POINTER,
		GTK_ARG_READWRITE | GTK_ARG_CONSTRUCT,
		ARG_RANK);
	gtk_object_add_arg_type("GoPlayer::strength",
		GTK_TYPE_DOUBLE,
		GTK_ARG_READWRITE | GTK_ARG_CONSTRUCT,
		ARG_STRENGTH);

	gtk_object_class->get_arg = ___object_get_arg;
	gtk_object_class->set_arg = ___object_set_arg;
	return;
	c = NULL;
	gtk_object_class = NULL;
#ifdef G_OBJECT_CLASS
	g_object_class = NULL;
#endif /* G_OBJECT_CLASS */
}
#undef __GOB_FUNCTION__

static void
___object_set_arg (GtkObject *object,
	GtkArg *arg,
	guint arg_id)
#define __GOB_FUNCTION__ "Go:Player::set_arg"
{
	GoPlayer *self;

	self = GO_PLAYER (object);

	switch (arg_id) {
	case ARG_NAME:
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define ARG ({gchar *  foo = GTK_VALUE_POINTER(*arg); foo; })
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define ARG ((gchar * )GTK_VALUE_POINTER(*arg))
#endif /* __GNUC__ && !__STRICT_ANSI__ */

		{
#line 68 "go-player.gob"
g_free(self->name); self->name = g_strdup(ARG);
#line 240 "go-player.c"
		}
		break;
#undef ARG
	case ARG_TOKEN:
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define ARG ({gchar *  foo = GTK_VALUE_POINTER(*arg); foo; })
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define ARG ((gchar * )GTK_VALUE_POINTER(*arg))
#endif /* __GNUC__ && !__STRICT_ANSI__ */

		{
#line 72 "go-player.gob"
g_free(self->token); self->token = g_strdup(ARG);
#line 254 "go-player.c"
		}
		break;
#undef ARG
	case ARG_RANK:
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define ARG ({gchar *  foo = GTK_VALUE_POINTER(*arg); foo; })
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define ARG ((gchar * )GTK_VALUE_POINTER(*arg))
#endif /* __GNUC__ && !__STRICT_ANSI__ */

		{
#line 76 "go-player.gob"
g_free(self->rank); self->rank = g_strdup(ARG);
#line 268 "go-player.c"
		}
		break;
#undef ARG
	case ARG_STRENGTH:
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define ARG ({double  foo = GTK_VALUE_DOUBLE(*arg); foo; })
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define ARG ((double )GTK_VALUE_DOUBLE(*arg))
#endif /* __GNUC__ && !__STRICT_ANSI__ */

		{
#line 80 "go-player.gob"
self->strength = ARG;
#line 282 "go-player.c"
		}
		break;
#undef ARG
	default:
		break;
	}
	return;
	self = NULL;
	arg = NULL;
}
#undef __GOB_FUNCTION__

static void
___object_get_arg (GtkObject *object,
	GtkArg *arg,
	guint arg_id)
#define __GOB_FUNCTION__ "Go:Player::get_arg"
{
	GoPlayer *self;

	self = GO_PLAYER (object);

	switch (arg_id) {
	case ARG_NAME:
#define ARG (GTK_VALUE_POINTER(*arg))
		{
#line 68 "go-player.gob"
ARG = g_strdup(self->name);
#line 311 "go-player.c"
		}
		break;
#undef ARG
	case ARG_TOKEN:
#define ARG (GTK_VALUE_POINTER(*arg))
		{
#line 72 "go-player.gob"
ARG = g_strdup(self->token);
#line 320 "go-player.c"
		}
		break;
#undef ARG
	case ARG_RANK:
#define ARG (GTK_VALUE_POINTER(*arg))
		{
#line 76 "go-player.gob"
ARG = g_strdup(self->rank);
#line 329 "go-player.c"
		}
		break;
#undef ARG
	case ARG_STRENGTH:
#define ARG (GTK_VALUE_DOUBLE(*arg))
		{
#line 80 "go-player.gob"
ARG = self->strength;
#line 338 "go-player.c"
		}
		break;
#undef ARG
	default:
		break;
	}
	return;
	self = NULL;
	arg = NULL;
}
#undef __GOB_FUNCTION__



/**
 * go_player_write:
 * @self: a #GoPlayer object
 * @node: a XML element of type "player"
 *
 * Dump all player data into @node.
 **/
#line 92 "go-player.gob"
void 
go_player_write (GoPlayer * self, xmlNodePtr node)
#line 363 "go-player.c"
{
	GoPlayerClass *klass;
#line 92 "go-player.gob"
	g_return_if_fail (self != NULL);
#line 92 "go-player.gob"
	g_return_if_fail (GO_IS_PLAYER (self));
#line 370 "go-player.c"
	klass = GO_PLAYER_GET_CLASS(self);

	if(klass->write)
		(*klass->write)(self,node);
}
#line 92 "go-player.gob"
static void 
___real_go_player_write (GoPlayer * self, xmlNodePtr node)
#line 379 "go-player.c"
{
#define __GOB_FUNCTION__ "Go:Player::write"
{
#line 94 "go-player.gob"
	
    xmlSetProp (node, "name", self->name);
    xmlSetProp (node, "token", self->token);
    if (self->rank)  xmlSetProp (node, "rank", self->rank);
    if (! self->rank && self->strength > -50) {
      char  buffer [32];
      g_snprintf (buffer, 32, "%f", self->strength);
      xmlSetProp (node, "strength", buffer);
    }
  }}
#line 394 "go-player.c"
#undef __GOB_FUNCTION__

#line 105 "go-player.gob"
static void 
___2_go_player_destroy (GtkObject * obj)
#line 400 "go-player.c"
#define PARENT_HANDLER(___obj) \
	{ if(GTK_OBJECT_CLASS(parent_class)->destroy) \
		(* GTK_OBJECT_CLASS(parent_class)->destroy)(___obj); }
{
#define __GOB_FUNCTION__ "Go:Player::destroy"
{
#line 107 "go-player.gob"
	
    GoPlayer *self = GO_PLAYER (obj);
    if (self->data)  go_data_remove_player (self->data, self);

    PARENT_HANDLER (obj);
  }}
#line 414 "go-player.c"
#undef __GOB_FUNCTION__
#undef PARENT_HANDLER

/**
 * go_player_new:
 * @data: a #GoData object
 * @name: the player's full name
 * @token: the player's abbreviation
 * @rank: the player's nominal rank, or %NULL
 * @strength: the player's numerical strength value
 *
 * Allocate a new #GoPlayer object, fill in the values,
 * and connect it to @data.  If the strength value is unknown
 * it should be set to %-100.
 *
 * Returns: a newly allocated #GoPlayer object.
 **/
#line 128 "go-player.gob"
GtkObject * 
go_player_new (GoData * data, const char * name, const char * token, const char * rank, double strength)
#line 435 "go-player.c"
{
#define __GOB_FUNCTION__ "Go:Player::new"
#line 128 "go-player.gob"
	g_return_val_if_fail (data != NULL, (GtkObject * )0);
#line 128 "go-player.gob"
	g_return_val_if_fail (GO_IS_DATA (data), (GtkObject * )0);
#line 128 "go-player.gob"
	g_return_val_if_fail (name != NULL, (GtkObject * )0);
#line 128 "go-player.gob"
	g_return_val_if_fail (token != NULL, (GtkObject * )0);
#line 446 "go-player.c"
{
#line 131 "go-player.gob"
	
    GtkObject *w;

    w = gtk_object_new (GO_TYPE_PLAYER,
			"name", name,
			"token", token,
			"rank", rank,
			"strength", strength,
			NULL);
    go_data_add_player (data, GO_PLAYER (w));
    return  w;
  }}
#line 461 "go-player.c"
#undef __GOB_FUNCTION__

/**
 * go_player_read:
 * @data: a #GoData object
 * @node: a XML element of type "player"
 *
 * This is a constructor for #GoPlayer objects,
 * which reads all data from a XML tree.
 *
 * Returns: a newly allocated #GoPlayer object.
 **/
#line 154 "go-player.gob"
GtkObject * 
go_player_read (GoData * data, xmlNodePtr node)
#line 477 "go-player.c"
{
#define __GOB_FUNCTION__ "Go:Player::read"
#line 154 "go-player.gob"
	g_return_val_if_fail (data != NULL, (GtkObject * )0);
#line 154 "go-player.gob"
	g_return_val_if_fail (GO_IS_DATA (data), (GtkObject * )0);
#line 484 "go-player.c"
{
#line 155 "go-player.gob"
	
    char *name, *token, *rank, *strength_str;
    double  strength;

    name = xmlGetProp (node, "name");
    token = xmlGetProp (node, "token");
    rank = xmlGetProp (node, "rank");
    strength_str = xmlGetProp (node, "strength");
    if (strength_str) {
      strength = str_to_double (strength_str, -100);
    } else if (! rank_to_strength (rank, &strength)) {
      g_warning ("invalid rank \"%s\"", rank);
      strength = -100;
    }
    return  go_player_new (data, name, token, rank, strength);
  }}
#line 503 "go-player.c"
#undef __GOB_FUNCTION__


#if (!defined __GNUC__) || (defined __GNUC__ && defined __STRICT_ANSI__)
/*REALLY BAD HACK
  This is to avoid unused warnings if you don't call
  some method.  I need to find a better way to do
  this, not needed in GCC since we use some gcc
  extentions to make saner, faster code */
static void
___go_player_really_bad_hack_to_avoid_warnings(void)
{
	((void (*)(void))write)();
	((void (*)(void))new)();
	((void (*)(void))read)();
	___go_player_really_bad_hack_to_avoid_warnings();
}
#endif /* !__GNUC__ || (__GNUC__ && __STRICT_ANSI__) */

