/* Generated by GOB (v1.0.10) on Sat Sep  1 19:43:01 2001
   (do not edit directly) */

/* End world hunger, donate to the World Food Programme, http://www.wfp.org */

#define GOB_VERSION_MAJOR 1
#define GOB_VERSION_MINOR 0
#define GOB_VERSION_PATCHLEVEL 10

#include "go-strengths.h"


#line 11 "go-strengths.gob"

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#define _GNU_SOURCE 1

#include <stdio.h>
#include <math.h>
#include <jvrand.h>

#include "go-player.h"
#include "go-history.h"


enum param_type { p_NORM, p_EXPNORM, p_CLAMP };
struct param {
  double *val;
  enum param_type  type;
  const char *name;
  union {
    struct {
      double  mu, ss;
    } norm;
    struct {
      double  emu, ess;
    } expnorm;
    struct {
      double  a, b;
    } clamp;
  } d;
};


#define	 P_JIGO_19  0.02
#define	 P_JIGO_13  0.04
#define	 P_JIGO_9  0.09

static  double  jo9, jo13, jo19;


static double
Phi (double x)
/* The distribution function of the standard normal distribution.  */
{
  return  (1+erf (x/M_SQRT2))/2;
}

static double
jigo_offset (double p_jigo)
/* Return the value x with Phi(+x)-Phi(-x) = P_JIGO.
 * P_JIGO is the jigo probability for even game.  */
{
  double  l, r, q;

  q = 0.5*(1+p_jigo);
  g_assert (0.5 <= q && q < Phi(1));
  l = 0;  r = 1;
  while (l+1e-6 < r) {
    double  m;
    g_assert (Phi(l) <= q && q < Phi(r));
    m = 0.5*(l+r);
    if (Phi(m) <= q) {
      l = m;
    } else {
      r = m;
    }
  }
  return  l;
}

static double
sqr (double x)
{
  return  x*x;
}


struct mod_fn_data {
  int  n, k;
  double  delta;
};

struct llh_fn_data {
  GoStrengths *s;
  double  value;
};

#line 103 "go-strengths.c"
/* self casting macros */
#define SELF(x) GO_STRENGTHS(x)
#define SELF_CONST(x) GO_STRENGTHS_CONST(x)
#define IS_SELF(x) GO_IS_STRENGTHS(x)
#define TYPE_SELF GO_TYPE_STRENGTHS
#define SELF_CLASS(x) GO_STRENGTHS_CLASS(x)

#define SELF_GET_CLASS(x) GO_STRENGTHS_GET_CLASS(x)

/* self typedefs */
typedef GoStrengths Self;
typedef GoStrengthsClass SelfClass;

/* GTK_CLASS_TYPE for 1.2<->1.3/2.0 GTK+ compatibility */
#ifndef GTK_CLASS_TYPE
#define GTK_CLASS_TYPE(x) (GTK_OBJECT_CLASS(x)->type)
#endif /* GTK_CLASS_TYPE */

/* here are local prototypes */
static void go_strengths_class_init (GoStrengthsClass * class) G_GNUC_UNUSED;
static void go_strengths_init (GoStrengths * self) G_GNUC_UNUSED;
static void go_strengths_destroy_hist_cb (gpointer key, gpointer value, gpointer data) G_GNUC_UNUSED;
static void ___4_go_strengths_destroy (GtkObject * obj) G_GNUC_UNUSED;
static void go_strengths_add_const_params (GoStrengths * self) G_GNUC_UNUSED;
static void go_strengths_remove_param (GoStrengths * self, double * val) G_GNUC_UNUSED;
static void go_strengths_add_norm_param (GoStrengths * self, const char * name, double * val, double mu, double ss, gboolean rnd) G_GNUC_UNUSED;
static void go_strengths_add_expnorm_param (GoStrengths * self, const char * name, double * val, double emu, double ess, gboolean rnd) G_GNUC_UNUSED;
static void go_strengths_add_clamp_param (GoStrengths * self, const char * name, double * val, double a, double b, gboolean rnd) G_GNUC_UNUSED;
static int go_strengths_parameters_count (GoStrengths * self) G_GNUC_UNUSED;
static double * go_strengths_parameters_dump (GoStrengths * self) G_GNUC_UNUSED;
static void go_strengths_parameters_restore (GoStrengths * self, double * mem) G_GNUC_UNUSED;
static void go_strengths_randomize (struct param * p) G_GNUC_UNUSED;
static void go_strengths_rand_cb (gpointer data, gpointer user_data) G_GNUC_UNUSED;
static void go_strengths_randomize_all (GoStrengths * self) G_GNUC_UNUSED;
static void go_strengths_modify (struct param * p, double d) G_GNUC_UNUSED;
static void go_strengths_mod_cb (gpointer data, gpointer user_data) G_GNUC_UNUSED;
static void go_strengths_randomize_some (GoStrengths * self) G_GNUC_UNUSED;
static void go_strengths_modify_some (GoStrengths * self, double delta) G_GNUC_UNUSED;
static void go_strengths_add_param_cb (GoHistory * h, double * param, gpointer data) G_GNUC_UNUSED;
static void go_strengths_remove_param_cb (GoHistory * h, double * param, gpointer data) G_GNUC_UNUSED;
static void ___18_go_strengths_register_player (GoClient * obj, GoPlayer * player) G_GNUC_UNUSED;
static void ___19_go_strengths_unregister_player (GoClient * obj, GoPlayer * player) G_GNUC_UNUSED;
static GoHistory * go_strengths_find_player_history (GoStrengths * self, GoPlayer * player) G_GNUC_UNUSED;
static void ___1b_go_strengths_register_game (GoClient * obj, GoGame * game) G_GNUC_UNUSED;
static double go_strengths_find_player_strength (GoStrengths * self, GoPlayer * player, GoGame * game) G_GNUC_UNUSED;
static void go_strengths_write_hist_cb (gpointer key, gpointer value, gpointer data) G_GNUC_UNUSED;
static void go_strengths_write_back_strengths (GoStrengths * self) G_GNUC_UNUSED;
static double go_strengths_mu19 (GoStrengths * self, double strength_b, double strength_w, int handicap, int komi) G_GNUC_UNUSED;
static double go_strengths_mu13 (GoStrengths * self, double strength_b, double strength_w, int handicap, int komi) G_GNUC_UNUSED;
static double go_strengths_mu9 (GoStrengths * self, double strength_b, double strength_w, int handicap, int komi) G_GNUC_UNUSED;
static double go_strengths_compensator (GoGame * g) G_GNUC_UNUSED;
static double go_strengths_prob_diff (GoStrengths * self, GoPlayer * black, GoPlayer * white, GoBoardSize board, int handicap, int kk) G_GNUC_UNUSED;
static void go_strengths_llh_fn (GoClient * c, GoGame * g, int i, int n, void * client_data) G_GNUC_UNUSED;
static double go_strengths_component_probability (GoStrengths * self) G_GNUC_UNUSED;

/* pointer to the class of our parent */
static GoClientClass *parent_class = NULL;

GtkType
go_strengths_get_type (void)
{
	static GtkType type = 0;

	if (type == 0) {
		static const GtkTypeInfo info = {
			"GoStrengths",
			sizeof (GoStrengths),
			sizeof (GoStrengthsClass),
			(GtkClassInitFunc) go_strengths_class_init,
			(GtkObjectInitFunc) go_strengths_init,
			/* reserved_1 */ NULL,
			/* reserved_2 */ NULL,
			(GtkClassInitFunc) NULL
		};

		type = gtk_type_unique (go_client_get_type(), &info);
	}

	return type;
}

/* Short form macros */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define destroy_hist_cb(args...) go_strengths_destroy_hist_cb(args)
#define add_const_params(args...) go_strengths_add_const_params(args)
#define new(args...) go_strengths_new(args)
#define remove_param(args...) go_strengths_remove_param(args)
#define add_norm_param(args...) go_strengths_add_norm_param(args)
#define add_expnorm_param(args...) go_strengths_add_expnorm_param(args)
#define add_clamp_param(args...) go_strengths_add_clamp_param(args)
#define parameters_print(args...) go_strengths_parameters_print(args)
#define parameters_count(args...) go_strengths_parameters_count(args)
#define parameters_dump(args...) go_strengths_parameters_dump(args)
#define parameters_restore(args...) go_strengths_parameters_restore(args)
#define randomize(args...) go_strengths_randomize(args)
#define rand_cb(args...) go_strengths_rand_cb(args)
#define randomize_all(args...) go_strengths_randomize_all(args)
#define modify(args...) go_strengths_modify(args)
#define mod_cb(args...) go_strengths_mod_cb(args)
#define randomize_some(args...) go_strengths_randomize_some(args)
#define modify_some(args...) go_strengths_modify_some(args)
#define add_param_cb(args...) go_strengths_add_param_cb(args)
#define remove_param_cb(args...) go_strengths_remove_param_cb(args)
#define find_player_history(args...) go_strengths_find_player_history(args)
#define find_player_strength(args...) go_strengths_find_player_strength(args)
#define write_hist_cb(args...) go_strengths_write_hist_cb(args)
#define write_back_strengths(args...) go_strengths_write_back_strengths(args)
#define mu19(args...) go_strengths_mu19(args)
#define mu13(args...) go_strengths_mu13(args)
#define mu9(args...) go_strengths_mu9(args)
#define probability(args...) go_strengths_probability(args)
#define compensator(args...) go_strengths_compensator(args)
#define prob_diff(args...) go_strengths_prob_diff(args)
#define find_handicap(args...) go_strengths_find_handicap(args)
#define find_komi(args...) go_strengths_find_komi(args)
#define llh_fn(args...) go_strengths_llh_fn(args)
#define component_probability(args...) go_strengths_component_probability(args)
#define optimize(args...) go_strengths_optimize(args)
#define check_preconditions(args...) go_strengths_check_preconditions(args)
#endif /* __GNUC__ && !__STRICT_ANSI__ */

/* Short form pointers */
static void (* const destroy_hist_cb) (gpointer key, gpointer value, gpointer data) = go_strengths_destroy_hist_cb;
static void (* const add_const_params) (GoStrengths * self) = go_strengths_add_const_params;
static GtkObject * (* const new) (GoData * data, gboolean optimize_constants) = go_strengths_new;
static void (* const remove_param) (GoStrengths * self, double * val) = go_strengths_remove_param;
static void (* const add_norm_param) (GoStrengths * self, const char * name, double * val, double mu, double ss, gboolean rnd) = go_strengths_add_norm_param;
static void (* const add_expnorm_param) (GoStrengths * self, const char * name, double * val, double emu, double ess, gboolean rnd) = go_strengths_add_expnorm_param;
static void (* const add_clamp_param) (GoStrengths * self, const char * name, double * val, double a, double b, gboolean rnd) = go_strengths_add_clamp_param;
static void (* const parameters_print) (GoStrengths * self) = go_strengths_parameters_print;
static int (* const parameters_count) (GoStrengths * self) = go_strengths_parameters_count;
static double * (* const parameters_dump) (GoStrengths * self) = go_strengths_parameters_dump;
static void (* const parameters_restore) (GoStrengths * self, double * mem) = go_strengths_parameters_restore;
static void (* const randomize) (struct param * p) = go_strengths_randomize;
static void (* const rand_cb) (gpointer data, gpointer user_data) = go_strengths_rand_cb;
static void (* const randomize_all) (GoStrengths * self) = go_strengths_randomize_all;
static void (* const modify) (struct param * p, double d) = go_strengths_modify;
static void (* const mod_cb) (gpointer data, gpointer user_data) = go_strengths_mod_cb;
static void (* const randomize_some) (GoStrengths * self) = go_strengths_randomize_some;
static void (* const modify_some) (GoStrengths * self, double delta) = go_strengths_modify_some;
static void (* const add_param_cb) (GoHistory * h, double * param, gpointer data) = go_strengths_add_param_cb;
static void (* const remove_param_cb) (GoHistory * h, double * param, gpointer data) = go_strengths_remove_param_cb;
static GoHistory * (* const find_player_history) (GoStrengths * self, GoPlayer * player) = go_strengths_find_player_history;
static double (* const find_player_strength) (GoStrengths * self, GoPlayer * player, GoGame * game) = go_strengths_find_player_strength;
static void (* const write_hist_cb) (gpointer key, gpointer value, gpointer data) = go_strengths_write_hist_cb;
static void (* const write_back_strengths) (GoStrengths * self) = go_strengths_write_back_strengths;
static double (* const mu19) (GoStrengths * self, double strength_b, double strength_w, int handicap, int komi) = go_strengths_mu19;
static double (* const mu13) (GoStrengths * self, double strength_b, double strength_w, int handicap, int komi) = go_strengths_mu13;
static double (* const mu9) (GoStrengths * self, double strength_b, double strength_w, int handicap, int komi) = go_strengths_mu9;
static double (* const probability) (GoStrengths * self, GoGame * g) = go_strengths_probability;
static double (* const compensator) (GoGame * g) = go_strengths_compensator;
static double (* const prob_diff) (GoStrengths * self, GoPlayer * black, GoPlayer * white, GoBoardSize board, int handicap, int kk) = go_strengths_prob_diff;
static int (* const find_handicap) (GoStrengths * self, GoPlayer * black, GoPlayer * white, GoBoardSize board) = go_strengths_find_handicap;
static double (* const find_komi) (GoStrengths * self, GoPlayer * black, GoPlayer * white, GoBoardSize board, int hc) = go_strengths_find_komi;
static void (* const llh_fn) (GoClient * c, GoGame * g, int i, int n, void * client_data) = go_strengths_llh_fn;
static double (* const component_probability) (GoStrengths * self) = go_strengths_component_probability;
static void (* const optimize) (GoStrengths * self) = go_strengths_optimize;
static const char * (* const check_preconditions) (GoStrengths * self) = go_strengths_check_preconditions;

/* a macro for creating a new object of our type */
#define GET_NEW ((GoStrengths *)gtk_type_new(go_strengths_get_type()))

#line 120 "go-strengths.gob"
static void 
go_strengths_class_init (GoStrengthsClass * class)
#line 269 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::class_init"
	GtkObjectClass *gtk_object_class = (GtkObjectClass *)class;
	GoClientClass *go_client_class = (GoClientClass *)class;

	parent_class = gtk_type_class (go_client_get_type ());

#line 154 "go-strengths.gob"
	gtk_object_class->destroy = ___4_go_strengths_destroy;
#line 439 "go-strengths.gob"
	go_client_class->register_player = ___18_go_strengths_register_player;
#line 457 "go-strengths.gob"
	go_client_class->unregister_player = ___19_go_strengths_unregister_player;
#line 477 "go-strengths.gob"
	go_client_class->register_game = ___1b_go_strengths_register_game;
#line 285 "go-strengths.c"
 {
#line 120 "go-strengths.gob"

    jo9 = jigo_offset (P_JIGO_9);
    jo13 = jigo_offset (P_JIGO_13);
    jo19 = jigo_offset (P_JIGO_19);
  
#line 293 "go-strengths.c"
 }
	return;
	class = NULL;
}
#undef __GOB_FUNCTION__
#line 126 "go-strengths.gob"
static void 
go_strengths_init (GoStrengths * self)
#line 302 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::init"
#line 11 "go-strengths.gob"
	self->optimize_constants = FALSE;
#line 307 "go-strengths.c"
#line 11 "go-strengths.gob"
	self->test_game = NULL;
#line 310 "go-strengths.c"
 {
#line 126 "go-strengths.gob"

    self->params = NULL;

    /* TODO: add better values here */
    self->s19 = 0.5;
    self->h19 = 1;
    self->k19 = 10;
    self->e19 = 5;

    self->s13 = 2;
    self->h13 = 2.6;
    self->k13 = 11.6;
    self->e13 = 3.75;

    self->s9 = 7.4;
    self->h9 = 5;
    self->k9 = 7.9;
    self->e9 = 2;

    self->histories = g_hash_table_new (NULL, NULL);
  
#line 334 "go-strengths.c"
 }
	return;
	self = NULL;
}
#undef __GOB_FUNCTION__



#line 148 "go-strengths.gob"
static void 
go_strengths_destroy_hist_cb (gpointer key, gpointer value, gpointer data)
#line 346 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::destroy_hist_cb"
{
#line 150 "go-strengths.gob"
	
    gtk_object_unref (GTK_OBJECT (value));
  }}
#line 354 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 154 "go-strengths.gob"
static void 
___4_go_strengths_destroy (GtkObject * obj)
#line 360 "go-strengths.c"
#define PARENT_HANDLER(___obj) \
	{ if(GTK_OBJECT_CLASS(parent_class)->destroy) \
		(* GTK_OBJECT_CLASS(parent_class)->destroy)(___obj); }
{
#define __GOB_FUNCTION__ "Go:Strengths::destroy"
{
#line 156 "go-strengths.gob"
	
    GoStrengths *self = GO_STRENGTHS (obj);

    if (self->test_game)  gtk_object_destroy (GTK_OBJECT (self->test_game));

    g_hash_table_foreach (self->histories, destroy_hist_cb, NULL);
    g_hash_table_destroy (self->histories);

    while (self->params) {
      GSList *head;

      head = self->params;
      self->params = head->next;
      g_free (head->data);
      g_slist_free_1 (head);
    }

    PARENT_HANDLER (obj);
  }}
#line 387 "go-strengths.c"
#undef __GOB_FUNCTION__
#undef PARENT_HANDLER

#line 176 "go-strengths.gob"
static void 
go_strengths_add_const_params (GoStrengths * self)
#line 394 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::add_const_params"
#line 176 "go-strengths.gob"
	g_return_if_fail (self != NULL);
#line 176 "go-strengths.gob"
	g_return_if_fail (GO_IS_STRENGTHS (self));
#line 401 "go-strengths.c"
{
#line 178 "go-strengths.gob"
	
    // add_expnorm_param (self, "s19", &self->s19, 0, 1, FALSE);

    // add_expnorm_param (self, "s13", &self->s13, 0.69, 1, FALSE);
    add_norm_param (self, "h13", &self->h13, 2.6, 1, FALSE);
    add_norm_param (self, "k13", &self->k13, 11.6, 1, FALSE);
    add_norm_param (self, "e13", &self->e13, 3.75, 1, FALSE);

    add_expnorm_param (self, "s9", &self->s9, 2, 1, FALSE);
    add_norm_param (self, "k9", &self->k9, 7.9, 1, FALSE);
    add_norm_param (self, "e9", &self->e9, 2, 1, FALSE);
    
    self->optimize_constants = TRUE;
  }}
#line 418 "go-strengths.c"
#undef __GOB_FUNCTION__

/**
 * go_strengths_new:
 * @data: a #GoData object
 * @optimize_constants: try to estimate some internal constants, too.
 *   This needs a lot of game data to give reasonable results.
 *
 * Allocate a new #GoStrength object and connect it to @data.
 *
 * Returns: the new object.
 **/
#line 203 "go-strengths.gob"
GtkObject * 
go_strengths_new (GoData * data, gboolean optimize_constants)
#line 434 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::new"
{
#line 205 "go-strengths.gob"
	
    GoStrengths *w;

    w = GET_NEW;
    go_data_add_client (data, GO_CLIENT(w));
    if (optimize_constants)  add_const_params (w);
    return  GTK_OBJECT (w);
  }}
#line 447 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 218 "go-strengths.gob"
static void 
go_strengths_remove_param (GoStrengths * self, double * val)
#line 453 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::remove_param"
#line 218 "go-strengths.gob"
	g_return_if_fail (self != NULL);
#line 218 "go-strengths.gob"
	g_return_if_fail (GO_IS_STRENGTHS (self));
#line 460 "go-strengths.c"
{
#line 220 "go-strengths.gob"
	
    GSList *node = self->params;

    while (node) {
      struct param *p = node->data;
      if (p->val == val)  break;
      node = node->next;
    }
    g_assert (node);
    self->params = g_slist_remove_link (self->params, node);
    g_free (node->data);
    g_slist_free_1 (node);
  }}
#line 476 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 234 "go-strengths.gob"
static void 
go_strengths_add_norm_param (GoStrengths * self, const char * name, double * val, double mu, double ss, gboolean rnd)
#line 482 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::add_norm_param"
#line 234 "go-strengths.gob"
	g_return_if_fail (self != NULL);
#line 234 "go-strengths.gob"
	g_return_if_fail (GO_IS_STRENGTHS (self));
#line 489 "go-strengths.c"
{
#line 237 "go-strengths.gob"
	
    struct param *p = g_new (struct param, 1);

    g_assert (ss > 0);
    p->val = val;
    p->type = p_NORM;
    p->name = name;
    p->d.norm.mu = mu;
    p->d.norm.ss = ss;
    self->params = g_slist_append (self->params, p);
    if (rnd)  randomize (p);
  }}
#line 504 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 250 "go-strengths.gob"
static void 
go_strengths_add_expnorm_param (GoStrengths * self, const char * name, double * val, double emu, double ess, gboolean rnd)
#line 510 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::add_expnorm_param"
#line 250 "go-strengths.gob"
	g_return_if_fail (self != NULL);
#line 250 "go-strengths.gob"
	g_return_if_fail (GO_IS_STRENGTHS (self));
#line 517 "go-strengths.c"
{
#line 253 "go-strengths.gob"
	
    struct param *p = g_new (struct param, 1);

    g_assert (ess > 0);
    p->val = val;
    p->type = p_EXPNORM;
    p->name = name;
    p->d.expnorm.emu = emu;
    p->d.expnorm.ess = ess;
    self->params = g_slist_append (self->params, p);
    if (rnd)  randomize (p);
  }}
#line 532 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 266 "go-strengths.gob"
static void 
go_strengths_add_clamp_param (GoStrengths * self, const char * name, double * val, double a, double b, gboolean rnd)
#line 538 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::add_clamp_param"
#line 266 "go-strengths.gob"
	g_return_if_fail (self != NULL);
#line 266 "go-strengths.gob"
	g_return_if_fail (GO_IS_STRENGTHS (self));
#line 545 "go-strengths.c"
{
#line 269 "go-strengths.gob"
	
    struct param *p = g_new (struct param, 1);

    g_assert (b > a);
    p->val = val;
    p->type = p_CLAMP;
    p->name = name;
    p->d.clamp.a = a;
    p->d.clamp.b = b;
    self->params = g_slist_append (self->params, p);
    if (rnd)  randomize (p);
  }}
#line 560 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 282 "go-strengths.gob"
void 
go_strengths_parameters_print (GoStrengths * self)
#line 566 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::parameters_print"
#line 282 "go-strengths.gob"
	g_return_if_fail (self != NULL);
#line 282 "go-strengths.gob"
	g_return_if_fail (GO_IS_STRENGTHS (self));
#line 573 "go-strengths.c"
{
#line 284 "go-strengths.gob"
	
    GSList *l;

    printf ("%d parameters total\n", g_slist_length (self->params));
    for (l=self->params; l; l=l->next) {
      if (((struct param *)l->data)->name) {
	printf ("param %s = %g\n", 
		((struct param *)l->data)->name,
		*((struct param *)l->data)->val);
      }
    }
  }}
#line 588 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 297 "go-strengths.gob"
static int 
go_strengths_parameters_count (GoStrengths * self)
#line 594 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::parameters_count"
#line 297 "go-strengths.gob"
	g_return_val_if_fail (self != NULL, (int )0);
#line 297 "go-strengths.gob"
	g_return_val_if_fail (GO_IS_STRENGTHS (self), (int )0);
#line 601 "go-strengths.c"
{
#line 299 "go-strengths.gob"
	
    return  g_slist_length (self->params);
  }}
#line 607 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 303 "go-strengths.gob"
static double * 
go_strengths_parameters_dump (GoStrengths * self)
#line 613 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::parameters_dump"
#line 303 "go-strengths.gob"
	g_return_val_if_fail (self != NULL, (double * )0);
#line 303 "go-strengths.gob"
	g_return_val_if_fail (GO_IS_STRENGTHS (self), (double * )0);
#line 620 "go-strengths.c"
{
#line 305 "go-strengths.gob"
	
    GSList *l;
    double *mem;
    int  i, n;

    n = g_slist_length (self->params);
    mem = g_new (double, n);

    for (l=self->params, i=0; l; l=l->next,++i) {
      mem[i] = *((struct param *)l->data)->val;
    }
    return  mem;
  }}
#line 636 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 319 "go-strengths.gob"
static void 
go_strengths_parameters_restore (GoStrengths * self, double * mem)
#line 642 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::parameters_restore"
#line 319 "go-strengths.gob"
	g_return_if_fail (self != NULL);
#line 319 "go-strengths.gob"
	g_return_if_fail (GO_IS_STRENGTHS (self));
#line 649 "go-strengths.c"
{
#line 321 "go-strengths.gob"
	
    GSList *l;
    int  i;

    for (l=self->params, i=0; l; l=l->next,++i) {
      *((struct param *)l->data)->val = mem[i];
    }
    g_free (mem);
  }}
#line 661 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 331 "go-strengths.gob"
static void 
go_strengths_randomize (struct param * p)
#line 667 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::randomize"
{
#line 333 "go-strengths.gob"
	
    switch (p->type) {
    case p_NORM:
      *p->val = jvrand_normal (p->d.norm.mu, p->d.norm.ss);
      break;
    case p_EXPNORM:
      *p->val = exp (jvrand_normal (p->d.expnorm.emu, p->d.expnorm.ess));
      break;
    case p_CLAMP:
      *p->val = jvrand_uniform (p->d.clamp.a, p->d.clamp.b);
      break;
    default:
      g_assert_not_reached ();
    }
  }}
#line 687 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 349 "go-strengths.gob"
static void 
go_strengths_rand_cb (gpointer data, gpointer user_data)
#line 693 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::rand_cb"
{
#line 351 "go-strengths.gob"
	
    randomize (data);
  }}
#line 701 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 355 "go-strengths.gob"
static void 
go_strengths_randomize_all (GoStrengths * self)
#line 707 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::randomize_all"
#line 355 "go-strengths.gob"
	g_return_if_fail (self != NULL);
#line 355 "go-strengths.gob"
	g_return_if_fail (GO_IS_STRENGTHS (self));
#line 714 "go-strengths.c"
{
#line 357 "go-strengths.gob"
	
    g_slist_foreach (self->params, rand_cb, NULL);
  }}
#line 720 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 361 "go-strengths.gob"
static void 
go_strengths_modify (struct param * p, double d)
#line 726 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::modify"
{
#line 363 "go-strengths.gob"
	
    double  x;

    switch (p->type) {
    case p_NORM:
      *p->val += jvrand_normal (0, d*p->d.norm.ss);
      break;
    case p_EXPNORM:
      *p->val *= exp (jvrand_normal (0, d*p->d.expnorm.ess));
      break;
    case p_CLAMP:
      x = *p->val + jvrand_normal (0, d*(p->d.clamp.b-p->d.clamp.a));
      *p->val = CLAMP (x, p->d.clamp.a, p->d.clamp.b);
      break;
    default:
      g_assert_not_reached ();
    }
  }}
#line 749 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 382 "go-strengths.gob"
static void 
go_strengths_mod_cb (gpointer data, gpointer user_data)
#line 755 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::mod_cb"
{
#line 384 "go-strengths.gob"
	
    struct mod_fn_data *mdata = user_data;
    double  x;

    x = mdata->k / (double)mdata->n;
    mdata->n -= 1;
    if (jvrand_uniform (0,1) < x)  return;
    if (mdata->delta <= 0) {
      randomize (data);
    } else {
      modify (data, mdata->delta);
    }
    mdata->k -= 1;
  }}
#line 774 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 399 "go-strengths.gob"
static void 
go_strengths_randomize_some (GoStrengths * self)
#line 780 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::randomize_some"
#line 399 "go-strengths.gob"
	g_return_if_fail (self != NULL);
#line 399 "go-strengths.gob"
	g_return_if_fail (GO_IS_STRENGTHS (self));
#line 787 "go-strengths.c"
{
#line 401 "go-strengths.gob"
	
    struct mod_fn_data  data;

    data.n = parameters_count (self);
    data.k = 1 + jvrand_poisson (1);
    data.delta = -1;
    g_slist_foreach (self->params, mod_cb, &data);
  }}
#line 798 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 410 "go-strengths.gob"
static void 
go_strengths_modify_some (GoStrengths * self, double delta)
#line 804 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::modify_some"
#line 410 "go-strengths.gob"
	g_return_if_fail (self != NULL);
#line 410 "go-strengths.gob"
	g_return_if_fail (GO_IS_STRENGTHS (self));
#line 811 "go-strengths.c"
{
#line 412 "go-strengths.gob"
	
    struct mod_fn_data  data;

    data.n = parameters_count (self);
    data.k = 1 + jvrand_poisson (1);
    data.delta = delta;
    g_slist_foreach (self->params, mod_cb, &data);
  }}
#line 822 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 425 "go-strengths.gob"
static void 
go_strengths_add_param_cb (GoHistory * h, double * param, gpointer data)
#line 828 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::add_param_cb"
{
#line 427 "go-strengths.gob"
	
    GoStrengths *self = GO_STRENGTHS (data);
    add_clamp_param (self, NULL, param, -45, 9, FALSE);
  }}
#line 837 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 432 "go-strengths.gob"
static void 
go_strengths_remove_param_cb (GoHistory * h, double * param, gpointer data)
#line 843 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::remove_param_cb"
{
#line 434 "go-strengths.gob"
	
    GoStrengths *self = GO_STRENGTHS (data);
    remove_param (self, param);
  }}
#line 852 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 439 "go-strengths.gob"
static void 
___18_go_strengths_register_player (GoClient * obj, GoPlayer * player)
#line 858 "go-strengths.c"
#define PARENT_HANDLER(___obj,___player) \
	{ if(GO_CLIENT_CLASS(parent_class)->register_player) \
		(* GO_CLIENT_CLASS(parent_class)->register_player)(___obj,___player); }
{
#define __GOB_FUNCTION__ "Go:Strengths::register_player"
{
#line 441 "go-strengths.gob"
	
    GoStrengths *self = GO_STRENGTHS (obj);

    if (! player->rank) {
      GtkObject *h = go_history_new (&player->strength);
      gtk_signal_connect (h, GO_HISTORY_SIGNAL_ADD_PARAMETER (add_param_cb), 
			  self);
      gtk_signal_connect (h, 
			  GO_HISTORY_SIGNAL_REMOVE_PARAMETER (remove_param_cb),
			  self);
      g_hash_table_insert (self->histories, player, h);
    }

    PARENT_HANDLER (obj, player);
  }}
#line 881 "go-strengths.c"
#undef __GOB_FUNCTION__
#undef PARENT_HANDLER

#line 457 "go-strengths.gob"
static void 
___19_go_strengths_unregister_player (GoClient * obj, GoPlayer * player)
#line 888 "go-strengths.c"
#define PARENT_HANDLER(___obj,___player) \
	{ if(GO_CLIENT_CLASS(parent_class)->unregister_player) \
		(* GO_CLIENT_CLASS(parent_class)->unregister_player)(___obj,___player); }
{
#define __GOB_FUNCTION__ "Go:Strengths::unregister_player"
{
#line 459 "go-strengths.gob"
	
    GoStrengths *self = GO_STRENGTHS (obj);
    GoHistory *h = find_player_history (self, player);

    if (h) {
      gtk_object_destroy (GTK_OBJECT (h));
      g_hash_table_remove (self->histories, player);
    }

    PARENT_HANDLER (obj, player);
  }}
#line 907 "go-strengths.c"
#undef __GOB_FUNCTION__
#undef PARENT_HANDLER

#line 471 "go-strengths.gob"
static GoHistory * 
go_strengths_find_player_history (GoStrengths * self, GoPlayer * player)
#line 914 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::find_player_history"
#line 471 "go-strengths.gob"
	g_return_val_if_fail (self != NULL, (GoHistory * )0);
#line 471 "go-strengths.gob"
	g_return_val_if_fail (GO_IS_STRENGTHS (self), (GoHistory * )0);
#line 921 "go-strengths.c"
{
#line 473 "go-strengths.gob"
	
    return  g_hash_table_lookup (self->histories, player);
  }}
#line 927 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 477 "go-strengths.gob"
static void 
___1b_go_strengths_register_game (GoClient * obj, GoGame * game)
#line 933 "go-strengths.c"
#define PARENT_HANDLER(___obj,___game) \
	{ if(GO_CLIENT_CLASS(parent_class)->register_game) \
		(* GO_CLIENT_CLASS(parent_class)->register_game)(___obj,___game); }
{
#define __GOB_FUNCTION__ "Go:Strengths::register_game"
{
#line 479 "go-strengths.gob"
	
    GoStrengths *self = GO_STRENGTHS (obj);
    GoGame *g = GO_GAME (game);
    GoHistory *h;

    h = find_player_history (self, g->black);
    if (h)  go_history_increase_length (h);
    h = find_player_history (self, g->white);
    if (h)  go_history_increase_length (h);

    PARENT_HANDLER (obj, game);
  }}
#line 953 "go-strengths.c"
#undef __GOB_FUNCTION__
#undef PARENT_HANDLER

#line 492 "go-strengths.gob"
static double 
go_strengths_find_player_strength (GoStrengths * self, GoPlayer * player, GoGame * game)
#line 960 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::find_player_strength"
#line 492 "go-strengths.gob"
	g_return_val_if_fail (self != NULL, (double )0);
#line 492 "go-strengths.gob"
	g_return_val_if_fail (GO_IS_STRENGTHS (self), (double )0);
#line 967 "go-strengths.c"
{
#line 494 "go-strengths.gob"
	
    GoHistory *h;
    int  i;

    h = find_player_history (self, player);
    if (GO_GAME(game)->fake || ! h)  return  ((GoPlayer *)player)->strength;
    i = go_data_player_game_index (((GoClient *)self)->data, player, game);
    return  go_history_get_strength (h, i);
  }}
#line 979 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 504 "go-strengths.gob"
static void 
go_strengths_write_hist_cb (gpointer key, gpointer value, gpointer data)
#line 985 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::write_hist_cb"
{
#line 506 "go-strengths.gob"
	
    go_history_write_back (GO_HISTORY (value));
  }}
#line 993 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 510 "go-strengths.gob"
static void 
go_strengths_write_back_strengths (GoStrengths * self)
#line 999 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::write_back_strengths"
#line 510 "go-strengths.gob"
	g_return_if_fail (self != NULL);
#line 510 "go-strengths.gob"
	g_return_if_fail (GO_IS_STRENGTHS (self));
#line 1006 "go-strengths.c"
{
#line 512 "go-strengths.gob"
	
    g_hash_table_foreach (self->histories, write_hist_cb, NULL);
  }}
#line 1012 "go-strengths.c"
#undef __GOB_FUNCTION__

/**
 * go_strengths_mu19:
 * @strength_b: strength value of black player
 * @strength_w: strength value of white player
 * @handicap: number of handicap stones
 * @komi: amount of komi
 *
 * Calculate the corrected strength difference for games on a 19x19 board.
 *
 * Returns: the corrected strength difference measured in player grades.
 *   Positive values indicate, that the game is in favour of black.
 **/
#line 532 "go-strengths.gob"
static double 
go_strengths_mu19 (GoStrengths * self, double strength_b, double strength_w, int handicap, int komi)
#line 1030 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::mu19"
#line 532 "go-strengths.gob"
	g_return_val_if_fail (self != NULL, (double )0);
#line 532 "go-strengths.gob"
	g_return_val_if_fail (GO_IS_STRENGTHS (self), (double )0);
#line 1037 "go-strengths.c"
{
#line 534 "go-strengths.gob"
	
    double  h = self->h19;
    double  k = self->k19;
    double  e = self->e19;
    double  x;

    x = strength_b - strength_w;
    x += h*(handicap>0 ? handicap-1 : 0);
    x -= h * (komi-e)/k;
    return  x;
  }}
#line 1051 "go-strengths.c"
#undef __GOB_FUNCTION__

/**
 * go_strengths_mu13:
 * @strength_b: strength value of black player
 * @strength_w: strength value of white player
 * @handicap: number of handicap stones
 * @komi: amount of komi
 *
 * Calculate the corrected strength difference for games on a 13x13 board.
 *
 * Returns: the corrected strength difference measured in player grades.
 *   Positive values indicate, that the game is in favour of black.
 **/
#line 558 "go-strengths.gob"
static double 
go_strengths_mu13 (GoStrengths * self, double strength_b, double strength_w, int handicap, int komi)
#line 1069 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::mu13"
#line 558 "go-strengths.gob"
	g_return_val_if_fail (self != NULL, (double )0);
#line 558 "go-strengths.gob"
	g_return_val_if_fail (GO_IS_STRENGTHS (self), (double )0);
#line 1076 "go-strengths.c"
{
#line 560 "go-strengths.gob"
	
    double  h = self->h13;
    double  k = self->k13;
    double  e = self->e13;
    double  x;

    x = strength_b - strength_w;
    x += h*(handicap>0 ? handicap-1 : 0);
    x -= h * (komi-e)/k;
    return  x;
  }}
#line 1090 "go-strengths.c"
#undef __GOB_FUNCTION__

/**
 * go_strengths_mu9:
 * @strength_b: strength value of black player
 * @strength_w: strength value of white player
 * @handicap: number of handicap stones
 * @komi: amount of komi
 *
 * Calculate the corrected strength difference for games on a 9x9 board.
 *
 * Returns: the corrected strength difference measured in player grades.
 *   Positive values indicate, that the game is in favour of black.
 **/
#line 584 "go-strengths.gob"
static double 
go_strengths_mu9 (GoStrengths * self, double strength_b, double strength_w, int handicap, int komi)
#line 1108 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::mu9"
#line 584 "go-strengths.gob"
	g_return_val_if_fail (self != NULL, (double )0);
#line 584 "go-strengths.gob"
	g_return_val_if_fail (GO_IS_STRENGTHS (self), (double )0);
#line 1115 "go-strengths.c"
{
#line 586 "go-strengths.gob"
	
    double  h = self->h9;
    double  k = self->k9;
    double  e = self->e9;
    double  x;

    x = strength_b - strength_w;
    x += h*(handicap>0 ? handicap-1 : 0);
    x -= h * (komi-e)/k;
    return  x;
  }}
#line 1129 "go-strengths.c"
#undef __GOB_FUNCTION__

/**
 * go_strengths_probability:
 * @self: a #GoStrengths object
 * @g: a #GoGame to evaluate
 *
 * Use the player data from the #GoStrengths object @self,
 * to assign a probability to the outcome of game @g.
 * This modifies the g->probability field.
 *
 * Returns: the probability that the given outcome of @g occurs
 **/
#line 609 "go-strengths.gob"
double 
go_strengths_probability (GoStrengths * self, GoGame * g)
#line 1146 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::probability"
#line 609 "go-strengths.gob"
	g_return_val_if_fail (self != NULL, (double )0);
#line 609 "go-strengths.gob"
	g_return_val_if_fail (GO_IS_STRENGTHS (self), (double )0);
#line 1153 "go-strengths.c"
{
#line 611 "go-strengths.gob"
	
    double  strength_b, strength_w;
    int  handicap, komi;
    double  mu, sigma, jo, p;

    strength_b = find_player_strength (self, g->black, g);
    strength_w = find_player_strength (self, g->white, g);
    handicap = g->handicap;
    komi = g->komi;

    /* avoid compiler warnings */
    mu = sigma = jo = p = 0;

    switch (g->board) {
    case b19:
      mu = mu19 (self, strength_b, strength_w, handicap, komi);
      sigma = self->s19;
      jo = jo19;
      break;
    case b13:
      mu = mu13 (self, strength_b, strength_w, handicap, komi);
      sigma = self->s13;
      jo = jo13;
      break;
    case b9:
      mu = mu9 (self, strength_b, strength_w, handicap, komi);
      sigma = self->s9;
      jo = jo9;
      break;
    default:
      g_assert_not_reached ();
    }

    switch (g->res) {
    case res_BLACK:
      p = 1 - Phi ((jo-mu)/sigma);
      break;
    case res_WHITE:
      if (g->with_jigo) {
	p = Phi ((-jo-mu)/sigma);
      } else {
	p = Phi ((jo-mu)/sigma);
      }
      break;
    case res_JIGO:
      if (g->with_jigo) {
	p = Phi ((jo-mu)/sigma) - Phi ((-jo-mu)/sigma);
      } else {
	g_assert_not_reached ();
      }
      break;
    default:
      g_assert_not_reached ();
    }

    g->probability = p;
    return  p;
  }}
#line 1214 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 670 "go-strengths.gob"
static double 
go_strengths_compensator (GoGame * g)
#line 1220 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::compensator"
{
#line 672 "go-strengths.gob"
	
    double  q = 0;

    if (g->with_jigo) {
      switch (g->board) {
      case b19:
	q = 2*sqr(0.5*(1-P_JIGO_19)) + sqr(P_JIGO_19);
	break;
      case b13:
	q = 2*sqr(0.5*(1-P_JIGO_13)) + sqr(P_JIGO_13);
	break;
      case b9:
	q = 2*sqr(0.5*(1-P_JIGO_9)) + sqr(P_JIGO_9);
	break;
      }
    } else {
      switch (g->board) {
      case b19:
	q = sqr(0.5*(1-P_JIGO_19)) + sqr(0.5*(1+P_JIGO_19));
	break;
      case b13:
	q = sqr(0.5*(1-P_JIGO_13)) + sqr(0.5*(1+P_JIGO_13));
	break;
      case b9:
	q = sqr(0.5*(1-P_JIGO_9)) + sqr(0.5*(1+P_JIGO_9));
	break;
      }
    }
    return  q;
  }}
#line 1255 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 703 "go-strengths.gob"
static double 
go_strengths_prob_diff (GoStrengths * self, GoPlayer * black, GoPlayer * white, GoBoardSize board, int handicap, int kk)
#line 1261 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::prob_diff"
#line 703 "go-strengths.gob"
	g_return_val_if_fail (self != NULL, (double )0);
#line 703 "go-strengths.gob"
	g_return_val_if_fail (GO_IS_STRENGTHS (self), (double )0);
#line 1268 "go-strengths.c"
{
#line 707 "go-strengths.gob"
	
    double  p_black, p_white;
    GoGame *g;

    if (! self->test_game) {
      GoData *data = (GoData *)GO_CLIENT(self)->data;
      g = (GoGame *)go_game_new_fake (data);
      self->test_game = g;
    } else {
      g = self->test_game;
    }

    g->black = black;
    g->white = white;
    g->board = board;
    g->handicap = handicap;
    if (kk%2 == 0) {
      g->komi = kk/2;
      g->with_jigo = TRUE;
    } else {
      g->komi = (kk-1)/2;
      g->with_jigo = FALSE;
    }
    g->res = res_BLACK;
    p_black = probability (self, g);
    g->res = res_WHITE;
    p_white = probability (self, g);

    return  (p_black - p_white);
  }}
#line 1301 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 738 "go-strengths.gob"
int 
go_strengths_find_handicap (GoStrengths * self, GoPlayer * black, GoPlayer * white, GoBoardSize board)
#line 1307 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::find_handicap"
#line 738 "go-strengths.gob"
	g_return_val_if_fail (self != NULL, (int )0);
#line 738 "go-strengths.gob"
	g_return_val_if_fail (GO_IS_STRENGTHS (self), (int )0);
#line 1314 "go-strengths.c"
{
#line 740 "go-strengths.gob"
	
    int  hc;

    for (hc = 2; hc < 14; ++hc) {
      if (prob_diff (self, black, white, board, hc, 0) >= 0)  break;
    }
    return  (hc > 2) ? hc-1 : 0;
  }}
#line 1325 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 749 "go-strengths.gob"
double 
go_strengths_find_komi (GoStrengths * self, GoPlayer * black, GoPlayer * white, GoBoardSize board, int hc)
#line 1331 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::find_komi"
#line 749 "go-strengths.gob"
	g_return_val_if_fail (self != NULL, (double )0);
#line 749 "go-strengths.gob"
	g_return_val_if_fail (GO_IS_STRENGTHS (self), (double )0);
#line 1338 "go-strengths.c"
{
#line 752 "go-strengths.gob"
	
    double  a, b, c;
    int  kk;

    kk = 0;
    while (prob_diff (self, black, white, board, hc, kk) >= 0.999)  ++kk;
    while (prob_diff (self, black, white, board, hc, kk) <= 0.001)  --kk;
    a = fabs (prob_diff (self, black, white, board, hc, kk-1));
    b = fabs (prob_diff (self, black, white, board, hc, kk));
    c = fabs (prob_diff (self, black, white, board, hc, kk+1));
    while (a<b && b<c) {
      kk -= 1;
      c = b;
      b = a;
      a = fabs (prob_diff (self, black, white, board, hc, kk-1));
    }
    while (a>b && b>c) {
      kk += 1;
      a = b;
      b = c;
      c = fabs (prob_diff (self, black, white, board, hc, kk+1));
    }
    return  0.5*kk;
  }}
#line 1365 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 777 "go-strengths.gob"
static void 
go_strengths_llh_fn (GoClient * c, GoGame * g, int i, int n, void * client_data)
#line 1371 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::llh_fn"
{
#line 779 "go-strengths.gob"
	
    struct llh_fn_data *data = client_data;

    if (go_data_players_equiv (GO_CLIENT(data->s)->data, g->black, g->white))
      data->value += log (probability (data->s, g) / compensator (g));
  }}
#line 1382 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 786 "go-strengths.gob"
static double 
go_strengths_component_probability (GoStrengths * self)
#line 1388 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::component_probability"
#line 786 "go-strengths.gob"
	g_return_val_if_fail (self != NULL, (double )0);
#line 786 "go-strengths.gob"
	g_return_val_if_fail (GO_IS_STRENGTHS (self), (double )0);
#line 1395 "go-strengths.c"
{
#line 790 "go-strengths.gob"
	
    struct  llh_fn_data  data;
    
    data.s = self;
    data.value = 0;
    go_client_foreach_game (GO_CLIENT(self), llh_fn, &data);
    return  data.value;
  }}
#line 1406 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 799 "go-strengths.gob"
void 
go_strengths_optimize (GoStrengths * self)
#line 1412 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::optimize"
#line 799 "go-strengths.gob"
	g_return_if_fail (self != NULL);
#line 799 "go-strengths.gob"
	g_return_if_fail (GO_IS_STRENGTHS (self));
#line 1419 "go-strengths.c"
{
#line 801 "go-strengths.gob"
	
    double  x;
    int  i;
    
    x = component_probability (self);
    for (i=0; i<100; ++i) {
      double *mem;
      double  y;

      mem = parameters_dump (self);
      if (i<2 || isinf(x)) {
	randomize_all (self);
      } else if (i<10) {
	randomize_some (self);
      } else if (i<20) {
	modify_some (self, 1);
      } else if (i<40) {
	modify_some (self, 0.1);
      } else if (i<70) {
	modify_some (self, 0.01);
      } else {
	modify_some (self, 0.001);
      }
      y = component_probability (self);
      if (y > x) {
	g_free (mem);
      } else {
	parameters_restore (self, mem);
      }
    }
    component_probability (self); /* fix the probability values */
    write_back_strengths (self);
    go_data_notify_players_changed (GO_CLIENT(self)->data);
    go_data_notify_games_changed (GO_CLIENT(self)->data);
    if (self->optimize_constants) {
      printf ("\ec");
      parameters_print (self);
      printf ("res = %g\n", x);
    }
  }}
#line 1462 "go-strengths.c"
#undef __GOB_FUNCTION__

#line 842 "go-strengths.gob"
const char * 
go_strengths_check_preconditions (GoStrengths * self)
#line 1468 "go-strengths.c"
{
#define __GOB_FUNCTION__ "Go:Strengths::check_preconditions"
#line 842 "go-strengths.gob"
	g_return_val_if_fail (self != NULL, (const char * )0);
#line 842 "go-strengths.gob"
	g_return_val_if_fail (GO_IS_STRENGTHS (self), (const char * )0);
#line 1475 "go-strengths.c"
{
#line 844 "go-strengths.gob"
	
    int  i, k, n;

    k = 0;
    n = go_client_player_count (GO_CLIENT (self));
    for (i=0; i<n; ++i) {
      GoPlayer *p = go_client_player (GO_CLIENT (self), i);
      if (p->rank)  ++k;
    }
    if (k == 0) {
      return  ("Cannot estimate strenghts.\n"
	       "At least one rank must be assigned.");
    } else if (k == n) {
      return  ("Nothing to do.\n"
	       "All ranks are explicitly assigned.");
    }
    return  NULL;
  }}
#line 1496 "go-strengths.c"
#undef __GOB_FUNCTION__


#if (!defined __GNUC__) || (defined __GNUC__ && defined __STRICT_ANSI__)
/*REALLY BAD HACK
  This is to avoid unused warnings if you don't call
  some method.  I need to find a better way to do
  this, not needed in GCC since we use some gcc
  extentions to make saner, faster code */
static void
___go_strengths_really_bad_hack_to_avoid_warnings(void)
{
	((void (*)(void))destroy_hist_cb)();
	((void (*)(void))add_const_params)();
	((void (*)(void))new)();
	((void (*)(void))remove_param)();
	((void (*)(void))add_norm_param)();
	((void (*)(void))add_expnorm_param)();
	((void (*)(void))add_clamp_param)();
	((void (*)(void))parameters_print)();
	((void (*)(void))parameters_count)();
	((void (*)(void))parameters_dump)();
	((void (*)(void))parameters_restore)();
	((void (*)(void))randomize)();
	((void (*)(void))rand_cb)();
	((void (*)(void))randomize_all)();
	((void (*)(void))modify)();
	((void (*)(void))mod_cb)();
	((void (*)(void))randomize_some)();
	((void (*)(void))modify_some)();
	((void (*)(void))add_param_cb)();
	((void (*)(void))remove_param_cb)();
	((void (*)(void))find_player_history)();
	((void (*)(void))find_player_strength)();
	((void (*)(void))write_hist_cb)();
	((void (*)(void))write_back_strengths)();
	((void (*)(void))mu19)();
	((void (*)(void))mu13)();
	((void (*)(void))mu9)();
	((void (*)(void))probability)();
	((void (*)(void))compensator)();
	((void (*)(void))prob_diff)();
	((void (*)(void))find_handicap)();
	((void (*)(void))find_komi)();
	((void (*)(void))llh_fn)();
	((void (*)(void))component_probability)();
	((void (*)(void))optimize)();
	((void (*)(void))check_preconditions)();
	___go_strengths_really_bad_hack_to_avoid_warnings();
}
#endif /* !__GNUC__ || (__GNUC__ && __STRICT_ANSI__) */

