/* main.c -
 *
 * Copyright (C) 2001  Jochen Voss.  */

static const  char  rcsid[] = "$Id: main.c,v 1.1.1.1 2001/08/24 20:40:58 voss Exp $";

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <locale.h>
#include <jvrand.h>
#include <gnome.h>

#include "go-player-list.h"
#include "go-game-list.h"
#include "go-game.h"

#include "golist.h"
#include "go.h"


int  main_loop_count = 0;
int  optimize_contants = FALSE;
GtkObject *data;


static  struct poptOption  options [] = {
  { "estimate-constants", 'e',
    POPT_ARG_NONE, &optimize_contants, 0,
    N_("Estimate some internal constants (needs a lot of data)"), NULL},
  { NULL, '\0', 0, NULL, 0, NULL, NULL }
};

int
main (int argc, char **argv)
{
  poptContext  pctx;
  const char **args;
  const char *filename = NULL;

  setlocale (LC_ALL, "");
  
#ifdef ENABLE_NLS
  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain (PACKAGE);
#endif

  jvrand_init ();
  gnome_init_with_popt_table ("golist", VERSION, argc, argv,
			      options, 0, &pctx);

  /* parse the command line options */
  args = poptGetArgs (pctx);
  if (args) {
    if (args[0] != NULL && args[1] != NULL) {
      g_error (_("At most one command line argument is allowed"));
    }
    filename = args[0];
  }
  poptFreeContext(pctx);

  data = go_data_new ();

  control_manager_open (filename);
  
  gtk_main ();
  
  gtk_object_destroy (data);

  return  0;
}
